<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="教师姓名" prop="teacherName">
        <el-input
          v-model="queryParams.teacherName"
          @keyup.enter.native="handleQuery"
          placeholder="请输入教师姓名"
          clearable
        />
      </el-form-item>
      <el-form-item label="工号" prop="teacherCode">
        <el-input
          v-model="queryParams.teacherCode"
          placeholder="请输入工号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="职务" prop="teacherPost">
        <el-input
          v-model="queryParams.teacherPost"
          placeholder="请输入职务"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:mentor:add']"
        > 新 增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:mentor:edit']"
        > 修 改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:mentor:remove']"
        > 删 除
        </el-button>
      </el-col>
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="warning"-->
      <!--          plain-->
      <!--          icon="el-icon-download"-->
      <!--          size="mini"-->
      <!--          @click="handleExport"-->
      <!--          v-hasPermi="['system:mentor:export']"-->
      <!--        >导出-->
      <!--        </el-button>-->
      <!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="mentorList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="照片" align="center">
        <template slot-scope="scope">
          <ListImage :image-url="baseUrl + scope.row.picUrl"></ListImage>
        </template>
      </el-table-column>
      <el-table-column label="姓名" align="center" prop="teacherName"/>
      <el-table-column label="工号" align="center" prop="teacherCode"/>
      <el-table-column label="职务" align="center" prop="teacherPost"/>
      <el-table-column label="电话号码" align="center" prop="teacherTel"/>
      <el-table-column label="家庭住址" align="center" prop="homeAddress"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:mentor:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:mentor:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!--选择老师-->
    <TeacherSelect
      v-if="teacherSelectDialog"
      :openSelect.sync="teacherSelectDialog"
      :title="teacherSelect"
      @getTeacherList="getTeacherList"
      @setTeacherInfo="setTeacherInfo"
    ></TeacherSelect>
    <!-- 添加或修改老师与班级关系对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>

      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="教师姓名" prop="teacherName">
          <el-input :disabled="disableTeacherName" v-model="form.teacherName" @click.native="openTeacherSelect"
                    placeholder="请输入教师姓名"/>
        </el-form-item>
        <el-form-item label="职务" prop="teacherPost">
          <el-input v-model="form.teacherPost" placeholder="请输入职务"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listMentor,
  getMentor,
  delMentor,
  addMentor,
  updateMentor
} from '@/api/smartSchool/teachAffairAdministration/affairClassManage/gradeMememberList';
import TeacherSelect from '@/views/components/moduleComponets/TeacherSelect/index.vue'
import {listInform} from "@/api/smartSchool/teacherManage/teacherInformation";

export default {
  name: "gradeMemberList",
  components: {TeacherSelect},
  data() {
    return {
      // 头像显示前缀
      baseUrl: process.env.VUE_APP_BASE_API,
      disableTeacherName: false,
      teacherSelect: '教师信息',
      teacherSelectDialog: false,
      gradeId: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 老师与班级关系表格数据
      mentorList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        teacherId: null,
        gradeId: null,
        startTime: null,
        endTime: null,
        teacherPost: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        delFlag: [
          {required: true, message: "$comment不能为空", trigger: "blur"}
        ],
      }
    };
  },
  created() {
    this.gradeId = this.$route.query && this.$route.query.gradeId
    this.getList();
  },
  activated() {
    this.gradeId = this.$route.query && this.$route.query.gradeId
    this.getList();
  },
  methods: {
    /** 查询老师与班级关系列表 */
    getList() {
      this.loading = true;
      listMentor(this.gradeId, this.queryParams).then(response => {
        this.mentorList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        teacherId: null,
        gradeId: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        delFlag: null,
        startTime: null,
        endTime: null,
        teacherPost: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.disableTeacherName = false
      this.open = true;
      this.title = "级部成员新增";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getMentor(id).then(response => {
        this.form = response.data;
        this.disableTeacherName = true
        this.open = true;
        this.title = "级部成员修改";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateMentor(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMentor(this.gradeId, this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除所选的数据项？').then(function () {
        return delMentor(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/mentor/export', {
        ...this.queryParams
      }, `mentor_${new Date().getTime()}.xlsx`)
    },
    openTeacherSelect() {
      this.teacherSelectDialog = true
    },
    // 新增操作
    setTeacherInfo(data) {
      this.teacherSelectDialog = false;
      this.$set(this.form, 'teacherName', data.teacherName);
      this.$set(this.form, 'teacherId', data.id);
      // this.dialogTeacherAward = true;
    },
    /** 获取教师信息列表 */
    getTeacherList(queryForm, callback) {
      listInform(queryForm).then(response => {
        callback(response.rows, response.total);
      }).catch(error => {
        callback([], 0);
      })
    },
  }
};
</script>
